part of persik;

class Item {
  String id;
  String description;
  DateTime finished_at;
  DateTime started_at;
  DateTime created_at;

  static List<Item> DefaultItems = null;

  clear() {
    id = null;
    description = '';
    finished_at = null;
    started_at = null;
    created_at = null;
  }

  Item.fromJson(Map data)  {
    if (null == data) {
      return;
    }
    id = data["id"];
    description = data["description"];
    finished_at = Utils.DateFromJsonValue(data["finished_at"]);
    started_at = Utils.DateFromJsonValue(data["started_at"]);
    created_at = Utils.DateFromJsonValue(data["created_at"]);
  }

  Map toJson() {
    Map map = new Map();
    map["id"] = id;
    map["description"] = description;
    if (finished_at != null) {
      map["finished_at"] = finished_at.toUtc().toIso8601String();
    }
    if (started_at != null) {
      map["started_at"] = started_at.toUtc().toIso8601String();
    }
    if (created_at != null) {
      map["created_at"] = created_at.toUtc().toIso8601String();
    }
    return map;
  }

  static List<Item> listFromJSONString(String data) {
    List<Item> result = new List<Item>();
    if (data != "null") {
      List list = JSON.decode(data);
      list.forEach((Map map) {
        result.add(new Item.fromJson(map));
      });
    }
    return result;
  }

  bool get isEmpty => description == null || description.isEmpty;

  bool get done => finished_at != null;

  void set done(bool isDone) {
    if (!isDone && finished_at != null) {
        finished_at = null;
    } else if (isDone && finished_at == null) {
        finished_at = new DateTime.now();
    }
  }
}
